﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace src
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            XrMapLib.IShapeMapLayer fromLyr = axXr1.Layers.GetLayerAsShapeMap("from");
            XrMapLib.IShapeMapLayer toLyr = axXr1.Layers.GetLayerAsShapeMap("to");

            if (fromLyr == null || toLyr == null)
            {
                MessageBox.Show("대상 레이어를 선택해주세요.");
                return;
            }


            XrMapLib.IShapeTable fromShp = fromLyr.ShapeTable;
            XrMapLib.IShapeTable toShp = toLyr.ShapeTable;
            XrMapLib.IAttributeTable fromAttr = fromLyr.AttributeTable;
            XrMapLib.IAttributeTable toAttr = toLyr.AttributeTable;

            XrMapLib.IShapeRow fromShpRow = null;
            XrMapLib.IShapeRow toShpRow = null;
            XrMapLib.IAttributeRow fromAttrRow = null;
            XrMapLib.IAttributeRow toAttrRow = null;

            int fromFID = 0;
            int toFID = 0;

            if (tbResult.Text.Length == 0)
            {
                MessageBox.Show("결과 파일명을 지정해주세요.");
                return;
            }

            if (cbFieldA.SelectedIndex == -1 || cbFieldB.SelectedIndex == -1)
            {
                MessageBox.Show("라벨로 표시할 필드를 선택해주세요.");
                return;
            }

            StreamWriter sw = new StreamWriter(tbResult.Text, false, System.Text.Encoding.Default);

            // write 1
            sw.Write(",");
            while ((toAttrRow = toAttr.GetRow(toFID)) != null)
            {
                if (toAttrRow.Load())
                {
                    String toName = toAttrRow.GetValueAsString(cbFieldB.SelectedIndex);

                    sw.Write(toName + ",");

                    toAttrRow.Unload();
                }

                toFID++;
            }

            sw.WriteLine();
            //.

            // write 2
            while ((fromAttrRow = fromAttr.GetRow(fromFID)) != null)
            {
                if (fromAttrRow.Load())
                {
                    fromShpRow = fromShp.GetRow(fromFID);
                    if (fromShpRow.Load())
                    {
                        String fromName = fromAttrRow.GetValueAsString(cbFieldA.SelectedIndex);
                        sw.Write(fromName +",");

                        XrMapLib.ICoordinate fromCoord = fromShpRow.GetVertex(0);
                        
                        toFID = 0;
                        while ((toShpRow = toShp.GetRow(toFID)) != null)
                        {
                            if (toShpRow.Load())
                            {
                                XrMapLib.ICoordinate toCoord = toShpRow.GetVertex(0);

                                double dist = Math.Sqrt(Math.Pow(fromCoord.X - toCoord.X, 2) + Math.Pow(fromCoord.Y - toCoord.Y, 2));
                                sw.Write(dist.ToString() + ",");
                            }

                            toFID++;
                            toShpRow.Unload();
                        }
                        sw.WriteLine();
                    }
                }

                fromShpRow.Unload();
                fromAttrRow.Unload();
                fromFID++;
            }
            //.

            sw.Close();

            MessageBox.Show("완료되었습니다.");
        }

        private void SelectSHPFile(String LayerName, TextBox tb, ComboBox cb)
        {
            openFileDialog.Filter = "SHP Files(*.shp)|*.shp";
            openFileDialog.FilterIndex = 0;

            DialogResult DR = openFileDialog.ShowDialog();
            if (DR == DialogResult.OK)
            {
                tb.Text = openFileDialog.FileName;

                axXr1.Layers.RemoveLayer(LayerName);
                axXr1.Layers.AddShapeMapLayer(LayerName, tb.Text);
                axXr1.WaitForAllConnections();

                XrMapLib.ShapeMapLayer lyr = axXr1.Layers.GetLayerAsShapeMap(LayerName);
                XrMapLib.FieldSet fs = lyr.AttributeTable.FieldSet;

                cb.Items.Clear();
                for (int iField = 0; iField < fs.FieldCount; ++iField)
                {
                    cb.Items.Add(fs.GetFieldName(iField));
                }

                if (cb.Items.Count > 0)
                {
                    cb.SelectedIndex = 0;
                }
            }
        }

        private void btnLayerA_Click(object sender, EventArgs e)
        {
            SelectSHPFile("from", tbLayerA, cbFieldA);
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btnLayerB_Click(object sender, EventArgs e)
        {
            SelectSHPFile("to", tbLayerB, cbFieldB);
        }

        private void btnResult_Click(object sender, EventArgs e)
        {
            saveFileDialog.Filter = "CSV Files(*.csv)|*.csv";
            saveFileDialog.FilterIndex = 0;

            DialogResult DR = saveFileDialog.ShowDialog();
            if (DR == DialogResult.OK)
            {
                tbResult.Text = saveFileDialog.FileName;
            }
        }
    }
}
  